function varargout = GridMethod_UI(varargin)
% GridMethod_UI MATLAB code for GridMethod_UI.fig
%      GridMethod_UI, by itself, creates a new GridMethod_UI or raises the existing
%      singleton*.
%
%      H = GridMethod_UI returns the handle to a new GridMethod_UI or the handle to
%      the existing singleton*.
%
%      GridMethod_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GridMethod_UI.M with the given input arguments.
%
%      GridMethod_UI('Property','Value',...) creates a new GridMethod_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GridMethod_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GridMethod_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GridMethod_UI

% Last Modified by GUIDE v2.5 06-Jun-2016 09:44:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @GridMethod_UI_OpeningFcn, ...
    'gui_OutputFcn',  @GridMethod_UI_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GridMethod_UI is made visible.
function GridMethod_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GridMethod_UI (see VARARGIN)

% Choose default command line output for GridMethod_UI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GridMethod_UI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = GridMethod_UI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_RefImg.
function pushbutton_RefImg_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_RefImg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.data.RefImgName,handles.data.RefImgPath] = uigetfile(fullfile('.','.tif'));
handles.RefImagePath.String = handles.data.RefImgName;
handles.data.RefImg = double(imread([handles.data.RefImgPath,'/',handles.data.RefImgName]));
axes(handles.axes_RefImg)
hold on
imagesc(handles.data.RefImg)
axis equal
xlim([1,size(handles.data.RefImg,2)])
ylim([1,size(handles.data.RefImg,1)])
guidata(hObject, handles);


% --- Executes on button press in pushbutton_RefImg.
function pushbutton_DefImg_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_RefImg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.data.DefImgName,handles.data.DefImgPath] = uigetfile(fullfile('.','.tif'));
handles.DefImagePath.String = handles.data.DefImgName;
handles.data.DefImg = double(imread([handles.data.DefImgPath,'/',handles.data.DefImgName]));
axes(handles.axes_DefImg)
hold on
imagesc(handles.data.DefImg)
axis equal
xlim([1,size(handles.data.DefImg,2)])
ylim([1,size(handles.data.DefImg,1)])
guidata(hObject, handles);


% --- Executes on button press in pushbutton_DefRoI.
function pushbutton_DefRoI_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_DefRoI (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
choice = menu('Choose a RoI definition mode','hand picked','line and column numbering');
switch choice
    case 1
        FigImgRef_tmp = figure();
        imagesc(handles.data.RefImg)
        title('Reference image')
        axis equal
        xlim([1,size(handles.data.RefImg,2)])
        ylim([1,size(handles.data.RefImg,1)])
        [x,y] = ginput(2);
        close(FigImgRef_tmp);
        handles.data.RoI = floor([min(y),max(y),min(x),max(x)]);
    case 2
        prompt = {'First line','Last line','First column:','Last column:'};
        dlg_title = 'Input';
        num_lines = 1;
        defaultans = {'1',num2str(size(handles.data.RefImg,1)),'1',num2str(size(handles.data.RefImg,2))};
        handles.data.RoI = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans)).';
end
handles.text_RoI.String = sprintf('RoI = [%i,%i,%i,%i]',handles.data.RoI);
handles.data.DefImgCroped = handles.data.DefImg(handles.data.RoI(1):handles.data.RoI(2),handles.data.RoI(3):handles.data.RoI(4));
handles.data.RefImgCroped = handles.data.RefImg(handles.data.RoI(1):handles.data.RoI(2),handles.data.RoI(3):handles.data.RoI(4));
axes(handles.axes_RefImg)
plot(handles.data.RoI([3 4 4 3 3]),handles.data.RoI([1 1 2 2 1]),'r','LineWidth',2)
guidata(hObject, handles);

% --- Executes on button press in pushbutton_RM.
function pushbutton_RM_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_RM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
choice1 = menu('Choose a restauration method','follow a hand picked point','automatic');
handles.data.Restauration.Method = choice1;
handles.data.Restauration.data = [0,0,0,0];
switch choice1
    case 1
        text_RM_tmp = 'Follow a point';
        FigImgRef_tmp = figure();
        imagesc(handles.data.RefImgCroped)
        title('Reference image - please select a point')
        axis equal
        xlim([1,size(handles.data.RefImgCroped,2)])
        ylim([1,size(handles.data.RefImgCroped,1)])
        [x,y] = ginput(1);
        close(FigImgRef_tmp);
        handles.data.Restauration.data([1 2]) = floor([y,x]);
        axes(handles.axes_RefImg)
        plot(handles.data.Restauration.data(2),handles.data.Restauration.data(1),'+g','LineWidth',2,'MarkerSize',10)
        
        FigImgDef_tmp = figure();
        imagesc(handles.data.DefImgCroped)
        title('Deformed image - please select a the same point')
        axis equal
        xlim([1,size(handles.data.DefImgCroped,2)])
        ylim([1,size(handles.data.DefImgCroped,1)])
        [x,y] = ginput(1);
        close(FigImgDef_tmp);
        handles.data.Restauration.data([3 4]) = floor([y,x]);
        axes(handles.axes_DefImg)
        plot(handles.data.Restauration.data(4),handles.data.Restauration.data(3),'+g','LineWidth',2,'MarkerSize',10)
    case 2
        text_RM_tmp = 'Automatic';
        choice2 = menu('Choose a restauration window definition mode','hand picked','line and column numbering');
        switch choice2
            case 1
                FigImgRef_tmp = figure();
                imagesc(handles.data.RefImgCroped)
                title('Reference image')
                axis equal
                xlim([1,size(handles.data.RefImgCroped,2)])
                ylim([1,size(handles.data.RefImgCroped,1)])
                [x,y] = ginput(2);
                close(FigImgRef_tmp);
                handles.data.Restauration.data = floor([min(y),max(y),min(x),max(x)]);                
            case 2
                prompt = {'First line','Last line','First column:','Last column:'};
                dlg_title = 'The coordinates are defined within the RoI';
                num_lines = 1;
                defaultans = {'1',num2str(size(handles.data.RefImg,1)),'1',num2str(size(handles.data.RefImg,2))};
                handles.data.Restauration.data = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans)).';
                
        end
        if handles.data.Restauration.data(2) - handles.data.Restauration.data(1) < 150
            fprintf('The window width is too small for the restauration process, it is enlarged\n')
            MeanPoint = mean(handles.data.Restauration.data([1 2]));
            handles.data.Restauration.data(1) = MeanPoint - 75;
            handles.data.Restauration.data(2) = MeanPoint + 75;
        end
        if handles.data.Restauration.data(4) - handles.data.Restauration.data(3) < 150
            fprintf('The window height is too small for the restauration process, it is enlarged\n')
            MeanPoint = mean(handles.data.Restauration.data([3 4]));
            handles.data.Restauration.data(3) = MeanPoint - 75;
            handles.data.Restauration.data(4) = MeanPoint + 75;
        end
        axes(handles.axes_RefImg)
        plot(handles.data.RoI(3)+handles.data.Restauration.data([3 4 4 3 3]),handles.data.RoI(1)+handles.data.Restauration.data([1 1 2 2 1]),'g','LineWidth',2)
end
handles.text_RM.String = ['Restauration method : ',text_RM_tmp];
guidata(hObject, handles);


% --- Executes on button press in pushbutton_CM.
function pushbutton_CM_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_CM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
choice1 = menu('Choose a compensation procedure','Nope','Iterative');
handles.data.Compensation.Method = choice1;
handles.data.Compensation.data = [];
text_CM_tmp = 'Nope';
if choice1==2
    text_CM_tmp = 'Iterative';
    prompt = {'Number of iterations'};
    dlg_title = 'Input';
    num_lines = 1;
    defaultans = {'1'};
    handles.data.Compensation.data = str2double(inputdlg(prompt,dlg_title,num_lines,defaultans)).';
end
handles.text_CM.String = ['Compensation method : ',text_CM_tmp];
guidata(hObject, handles);

% --- Executes on button press in pushbutton_Output.
function pushbutton_Output_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ListString = {'Ux','Uy','Eps_xx','Eps_yy','Eps_xy'};
s = listdlg('PromptString','Select the output you want to see:','SelectionMode','Multiple','ListString',ListString);
handles.data.Output = ListString(s);
guidata(hObject, handles);

function edit_GridPitch_Callback(hObject, eventdata, handles)
% hObject    handle to edit_GridPitch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.data.GridPitch = str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_GridPitch_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_GridPitch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.data.GridPitch = str2double(get(hObject,'String'));
guidata(hObject, handles);

function edit_GW_std_Callback(hObject, eventdata, handles)
% hObject    handle to edit_GW_std (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.data.WindowStd = str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_GW_std_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_GW_std (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.data.WindowStd = str2double(get(hObject,'String'));
guidata(hObject, handles);

% --- Executes on button press in pushbutton_Solve.
function pushbutton_Solve_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Solve (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
addpath('../functions');

p       = handles.data.GridPitch; % pattern pitch
imgrid1 = double(handles.data.RefImg(handles.data.RoI(1):handles.data.RoI(2),handles.data.RoI(3):handles.data.RoI(4)));
imgrid2 = double(handles.data.DefImg(handles.data.RoI(1):handles.data.RoI(2),handles.data.RoI(3):handles.data.RoI(4)));

g = build_window(0,handles.data.WindowStd);
[PHI1_X,PHI1_Y] = LSA( imgrid1, g, p);
[PHI2_X,PHI2_Y] = LSA( imgrid2, g, p);

PHI1_X=unwrap2D(single(PHI1_X));
PHI1_Y=unwrap2D(single(PHI1_Y));
PHI2_X=unwrap2D(single(PHI2_X));
PHI2_Y=unwrap2D(single(PHI2_Y));

[k,l] = register_gridimages(handles.data.Restauration.Method, handles.data.Restauration.data, p,imgrid1, imgrid2, PHI1_X, PHI1_Y, PHI2_X, PHI2_Y );

PHI2_X=PHI2_X+l*2*pi;
PHI2_Y=PHI2_Y+k*2*pi;

[ UX, UY, EPSXX, EPSYY, EPSXY] = calculate_U_EPS(handles.data.Compensation.Method, p, PHI1_X, PHI1_Y, PHI2_X, PHI2_Y);

for iplot = 1:size(handles.data.Output,2)
    figure
    switch handles.data.Output{iplot}
        case 'Ux'
            imagesc(UX)
            title('U_{x}')
        case 'Uy'
            imagesc(UY)
            title('U_{y}')
        case 'Eps_xx'
            imagesc(EPSXX)
            title('Eps_{xx}')
        case 'Eps_yy'
            imagesc(EPSYY)
            title('Eps_{yy}')
        case 'Eps_xy'
            imagesc(EPSXY)
            title('Eps_{xy}')
    end
    colorbar
    axis equal
    xlabel('x-dimension')
    ylabel('y-dimension')
    xlim([1,size(EPSXY,2)])
    ylim([1,size(EPSXY,1)])
end
