% generate synthetic grids
%%%%%%%%%%%%%%%%%%%%%%%%%%

type_noise = 2; 
% (0: no noise, 1: Gaussian white noise (set stdnoise), 2: signal-dependent noise)
std_noise=30;

pixels_par_periode=7; 
taille_x=2000;
taille_y=500;

% defining phase maps
amplitude_derivee_phase=0.005;
periode_mini=2;
periode_maxi=80;
A=2048;
gamma=0.9;
decalage_origine=round(taille_y/2);
[I,J]=meshgrid(1:taille_x,1:taille_y);
periode=I*(periode_maxi-periode_mini)/taille_x+periode_mini;
Phase_Y=amplitude_derivee_phase/2/pi*periode.*sin(2*pi./periode.*(J-decalage_origine));
Phase_X=zeros(size(Phase_Y));
Phase_X(:,round(taille_x/2)-50:round(taille_x/2)+50)=50*amplitude_derivee_phase*ones(taille_y,1)*triang(101)';
save 'data/Phases.mat' Phase_X Phase_Y;


% synthetic images on 12 bits


% non-deformed grid image

Image=A+A/2*gamma*sin(2*pi/pixels_par_periode*(I-1)).^3+A/2*gamma*sin(2*pi/pixels_par_periode*(J-1)).^3;

switch type_noise
    case 0
        noise=zeros(size(Image));
    case 1
        stdnoise=30;
        noise=stdnoise*randn(size(Image));
    case 2
        noise=sqrt(abs(0.519*Image+1.33^2-0.519*45.46)).*randn(size(Image));
end;
Image=round(Image+noise);
Image(Image<0)=0;
Image(Image>2^12)=2^12;
imwrite(2^4*uint16(Image), 'data/ref_synthetic_grid.tif');


% deformed grid image

Image=A+A/2*gamma*sin(2*pi/pixels_par_periode*(I-1)+Phase_X).^3+A/2*gamma*sin(2*pi/pixels_par_periode*(J-1)+Phase_Y).^3;

switch type_noise
    case 0
        noise=zeros(size(Image));
    case 1
        stdnoise=30;
        noise=stdnoise*randn(size(Image));
    case 2
        noise=sqrt(abs(0.519*Image+1.33^2-0.519*45.46)).*randn(size(Image));
end;
Image=round(Image+noise);
Image(Image<0)=0;
Image(Image>2^12)=2^12;
imwrite(2^4*uint16(Image), 'data/modulated_synthetic_grid.tif');

